Bug 1452649 - Review Request: python-exabgp - Package review request for ExaBGP spec
Summary: Review Request: python-exabgp - Package review request for ExaBGP spec
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Richard W.M. Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: RDO-PIKE
TreeView+ depends on / blocked
 
Reported: 2017-05-19 12:14 UTC by Luke Hinds
Modified: 2017-07-06 08:31 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-07-06 08:31:48 UTC
rjones: fedora-review+


Attachments (Terms of Use)
rpmlint errors (36.20 KB, text/plain)
2017-05-22 11:17 UTC, Richard W.M. Jones
no flags Details

Description Luke Hinds 2017-05-19 12:14:56 UTC
Spec URL: https://raw.githubusercontent.com/lukehinds/ExaBGP-Packaging/master/python-exabgp.spec
SRPM URL: https://github.com/lukehinds/ExaBGP-Packaging/raw/master/python-exabgp-4.0.0-1.fc25.src.rpm
Description: ExaBGP provides a convenient way to implement Software Defined Networking by transforming BGP messages into friendly plain text or JSON, which can then be easily handled by simple scripts or your BSS/OSS.
Fedora Account System Username:lhinds


This is my first package to Fedora so I need a sponsor. I am familiar with maintaining packages in the RDO project where I maintain the bagpipe-bgp package.

The package has been successfully built with rpmbuild on a Fedora 25 system, and installed to insure functionality.

Comment 1 Richard W.M. Jones 2017-05-22 10:54:37 UTC
warning: bogus date in %changelog: Tue May 18 2015 Luke Hinds <lhinds@redhat.com> - 4.0.0
warning: bogus date in %changelog: Tue May 18 2015 Luke Hinds <lhinds@redhat.com> - 4.0.0

Comment 2 Richard W.M. Jones 2017-05-22 10:56:21 UTC
You might want to take a look at:
https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file

In particular, the Source url is (probably) wrong.  It would be good
to have a full link to the tarball there.

Comment 3 Richard W.M. Jones 2017-05-22 11:17:17 UTC
Created attachment 1280996 [details]
rpmlint errors

rpmlint gives a really long list of errors.  I didn't check them
in detail, and possibly some are caused by my build environment,
but they are attached here so please take a look.

Comment 4 Luke Hinds 2017-05-22 15:19:02 UTC
Hey Rich,

I refreshed the following that fixes rpmlint errors (without the --all flag)

$ rpmlint python-exabgp.spec                                                                                       
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

spec URL: https://raw.githubusercontent.com/lukehinds/ExaBGP-Packaging/master/python-exabgp.spec

SRPM URL: https://github.com/lukehinds/ExaBGP-Packaging/raw/master/python-exabgp-4.0.0-1.fc25.src.rpm

In your verbose log, I am not to sure what to do with some, as they don't make an awful lot of sense:

non-standard-executable-perm /etc/exabgp/examples/aggregator.conf 744

I think other stuff like 'wrong-script-interpreter' is due the python scripts being libraries, more then executables. 

What flags are passing to rpmbuild so I can replicate your workflow?

Comment 5 Richard W.M. Jones 2017-05-22 16:51:36 UTC
I'm using:

$ fedora-review -b 1452649

I don't know what build options it uses by default.  Anyway,
I'm doing another run now using the latest URLs.

Comment 6 Richard W.M. Jones 2017-05-22 17:09:10 UTC
Fedora-review is complaining that the spec file and the spec file inside
the SRPM (both linked from comment 4) are slightly different, but it's
only the %description which is different, so don't worry about it for now.

A few issues about the spec file in general.

- %defattr is not needed.  It can be deleted.
- Group is not needed.  It can be deleted.
- The %{!?...} lines at the top are not needed in Fedora (not sure about RHEL).

I'm still seeing a large number of rpmlint errors, so let's see:

python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/application/bmp.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/bmp.py 644 /usr/bin/env python

 - This (and similar) is likely to be wrong, unless (a) that file is
   really a script rather than a library and (b) it can run under
   any version of python2 (or any version of python if we later
   rename python3 -> python).  However the Python Packaging Guidelines
   seem to be silent on this so I don't know if it's a packaging bug.

exabgp.noarch: E: description-line-too-long C ExaBGP allows engineers to control their network from commodity servers. Think of it as Software Defined Networking using BGP by transforming BGP messages into friendly plain text or JSON.

 - Worth folding the lines at 72 chars I guess.

exabgp.noarch: E: non-standard-executable-perm /etc/exabgp/examples/addpath.conf 744
exabgp.noarch: E: script-without-shebang /etc/exabgp/examples/addpath.conf

 - That doesn't make much sense for any file.  Should it be 0644?
   In the spec file:
   %attr(744, root, root) %{_sysconfdir}/exabgp/examples/*

exabgp.noarch: W: spurious-executable-perm /usr/share/man/man1/exabgp.1.gz
exabgp.noarch: W: manual-page-warning /usr/share/man/man1/exabgp.1.gz 3: warning: macro `OS' not defined
exabgp.noarch: W: spurious-executable-perm /usr/share/man/man5/exabgp.conf.5.gz
exabgp.noarch: W: manual-page-warning /usr/share/man/man5/exabgp.conf.5.gz 3: warning: macro `OS' not defined

 - Should be fixable I think?

Comment 7 Luke Hinds 2017-05-23 10:28:43 UTC
Hi Rich,

Fixed up quite a lot now. Some notes:

- %defattr is not needed.  It can be deleted.

done

- Group is not needed.  It can be deleted.

done

- The %{!?...} lines at the top are not needed in Fedora (not sure about RHEL).

I did try removing these, but they appear to be needed for  %{__python2}, %{python2_sitelib} directives to work. Some details here: https://fedoraproject.org/wiki/Packaging:Python_Old (see Macros)

This package will be cherry picked(?) into CentOS / RHEL for RDO use, so needs those.

- exabgp.noarch: E: description-line-too-long

done

- exabgp.noarch: E: non-standard-executable-perm

done


- exabgp.noarch: W: spurious-executable-perm /usr/share/man/man1/exabgp.1.gz
- exabgp.noarch: W: manual-page-warning /usr/share/man/man1/exabgp.1.gz 3: warning: macro `OS' not defined
- exabgp.noarch: W: spurious-executable-perm /usr/share/man/man5/exabgp.conf.5.gz
- exabgp.noarch: W: manual-page-warning /usr/share/man/man5/exabgp.conf.5.gz 3: warning: macro `OS' not defined

Not sure what to do about these, I did google around and could only find an old comment from yours truly: https://bugzilla.redhat.com/show_bug.cgi?id=467397#c4

p.s. latest files are commited to the original links, so a fedora-review -b will pull in the latest changes.

Comment 8 Richard W.M. Jones 2017-05-23 11:30:18 UTC
%doc COPYRIGHT

should be

%license COPYRIGHT

The other two %doc files are OK as they are not license files.
Unfortunately I don't think that %license will work on RHEL
so you may need some %if's around that.

The package couldn't be installed (in a chroot).  However fedora-review
doesn't keep the actual error from that, so it might just be an error
caused by the systemd unit scripts.

The exabgp package depends on /usr/bin/perl which seems to be a bug.
Although the documentation mentions "a perl based healthcheck program",
the one included in this package is most definitely written in Python,
and there are no other perl binaries or libraries that I can see.

There are still loads of rpmlint errors of this kind:

  exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-announcement.run 644 /usr/bin/env python

rpmlint is literally correct here that there is a script which is not
executable.  Is it intended that the end user will chmod +x the script(s)
that they need?

Another rpmlint problem is:

  exabgp.noarch: W: non-conffile-in-etc /etc/exabgp/examples/api-api.conf         

If these files are meant to be edited, then they must be marked as %config
or %config(noreplace) in the spec:

  https://fedoraproject.org/wiki/Packaging:Guidelines#Configuration_files

If they are not meant to be edited (just symlinked to) then
I guess moving them to /usr/lib/exabgp is a better idea?

Comment 9 Luke Hinds 2017-05-24 09:19:33 UTC
Hi Richard,

I have some updates:

- %license COPYRIGHT

done

- The exabgp package depends on  /usr/bin/perl

This is from two perl scripts which are examples of what can be used for monitoring routes. Neither require modules outside of the standard set included in perl. The main library will work fine without perl in place, as you rightly noted around python being the main lang. So no Requires or BuildRequires needed.

-  exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-announcement.run 644 /usr/bin/env python

I spoke with a developer on IRC and they said that these do not need to be executionable, as they are only there as examples for people to reference of use if it suits their needs.

- exabgp.noarch: W: non-conffile-in-etc /etc/exabgp/examples/api-api.conf

Same again as the above, examples for users to reference..the recommendation would be to copy them out and then amend, but most folks write their own.

- wrong-script-interpreter /etc/exabgp/examples/api-multisession.run /usr/bin/env python

Upstream prefers not to change it to a fixed path, and instead use env for python virtualenv use (I figure you already knew this from being a python man, so that's why you omitted mentioning).

So the only others now are:

- spurious-executable-perm /usr/share/man/man1/exabgp.1.gz
- manual-page-warning /usr/share/man/man1/exabgp.1.gz 3: warning: macro `OS' not defined
- exabgp.noarch: W: no-manual-page-for-binary exabgp-healthcheck

I guess the above can be waived as they are warnings and not errors?

Original links have been refreshed. Latest review.txt here: https://paste.fedoraproject.org/paste/mV-hAsjKX8pNkdvL-lYNe15M1UNdIGYhyRLivL9gydE= 

p.s. thanks for time walking this through with me.

Comment 10 Richard W.M. Jones 2017-05-25 09:49:52 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

I'm going to ignore this one because (a) it could be a local issue
(b) fedora-review / systemd / whatever throws away the actual error
message so I've no idea what the problem is.

- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions

Discussed extensively on this review bug, see previous comments.

- Package contains BR: python2-devel or python3-devel

I don't know why fedora-review prints this, but according to the
Python packaging guidelines this is fine.

- Package does not contain duplicates in %files.
  Note: warning: File listed twice: /etc/exabgp/exabgp.conf
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles

This is a bug.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

3 clause BSD.

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "MIT/X11 (BSD like)", "Unknown or generated",
     "*No copyright* BSD (unspecified)". 587 files have unknown license.
     Detailed output of licensecheck in /var/tmp/1452649-python-
     exabgp/licensecheck.txt

Upstream could add proper notices to more files, but it doesn't look
as if there is anything wrong.

[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/exabgp
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/exabgp

Probably need to add %dir for this directory.

By the way, in the spec you can use %{_datadir} instead of
%{_prefix}/share.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed

%defattr isn't required even for RHEL 7, so this should be deleted
unless you're really intending to use this spec file for ancient
versions of RPM.

[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

It seems as if the exabgp subpackage should have
‘Requires: %{name} = %{version}-%{release}’.

Currently the exabgp package requires ‘config(exabgp)’ which
python-exabgp provides, but that won't be sufficient to pull in the
correct version.

[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.

Package seems to be written entirely in Python, so it should be fine.

[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 163840 bytes in 4 files.
[ ]: Package complies to the Packaging Guidelines

Possibly, but I still think the not-really-config /etc/exabgp/examples
files should be moved to /usr/lib/exabgp.

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build
     process.

I didn't check this, but I guess they don't.  In any case you'll
quickly find out when you build this in Koji.

[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).

I suspect exabgp should require python-exabgp.  The other dependencies
look fine.

[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in exabgp

See above.

[?]: Package functions as described.
[x]: Latest version is packaged.

Yes.  Latest upstream version is also 4.0.0.

[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint

Actually the mock build didn't fail, but the install failed.  See
above.

[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.4.1 starting (python version = 3.6.1)...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled HW Info plugin
Mock Version: 1.4.1
INFO: Mock Version: 1.4.1
Finish: chroot init
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled HW Info plugin
Mock Version: 1.4.1
INFO: Mock Version: 1.4.1
Finish: chroot init
INFO: installing package(s): /var/tmp/1452649-python-exabgp/results/exabgp-4.0.0-1.fc26.noarch.rpm /var/tmp/1452649-python-exabgp/results/python-exabgp-4.0.0-1.fc26.noarch.rpm
ERROR: Command failed: 
 # /usr/bin/systemd-nspawn -q -M 5ae0e883fefc44b4b1d82854759824ba -D /var/lib/mock/fedora-26-x86_64-bootstrap/root -a --setenv=TERM=vt100 --setenv=SHELL=/bin/bash --setenv=HOME=/builddir --setenv=HOSTNAME=mock --setenv=PATH=/usr/bin:/bin:/usr/sbin:/sbin --setenv=PROMPT_COMMAND=printf "\033]0;<mock-chroot>\007" --setenv=PS1=<mock-chroot> \s-\v\$  --setenv=LANG=en_GB.UTF-8 --setenv=LC_MESSAGES=C /usr/bin/dnf --installroot /var/lib/mock/fedora-26-x86_64/root/ --releasever 26 --disableplugin=local --setopt=deltarpm=false install /var/tmp/1452649-python-exabgp/results/exabgp-4.0.0-1.fc26.noarch.rpm /var/tmp/1452649-python-exabgp/results/python-exabgp-4.0.0-1.fc26.noarch.rpm



Rpmlint
-------
Checking: python-exabgp-4.0.0-1.fc26.noarch.rpm
          exabgp-4.0.0-1.fc26.noarch.rpm
          python-exabgp-4.0.0-1.fc26.src.rpm
python-exabgp.noarch: W: spelling-error Summary(en_US) swiss -> swiz, Swiss, swigs
python-exabgp.noarch: W: incoherent-version-in-changelog 4.0.0 ['4.0.0-1.fc26', '4.0.0-1']
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/application/bmp.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/bmp.py 644 /usr/bin/env python
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/application/cli.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/cli.py 644 /usr/bin/env python
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/application/healthcheck.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/healthcheck.py 644 /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/netlink.py 644 /usr/bin/python 
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/application/tojson.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/application/tojson.py 644 /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/netlink/old.py 644 /usr/bin/python 
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/reactor/api/options.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/reactor/api/options.py 644 /usr/bin/env python
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/reactor/api/response/json.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/reactor/api/response/json.py 644 /usr/bin/env python
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/reactor/api/response/text.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/reactor/api/response/text.py 644 /usr/bin/env python
python-exabgp.noarch: E: wrong-script-interpreter /usr/lib/python2.7/site-packages/exabgp/vendoring/bitstring.py /usr/bin/env python
python-exabgp.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/exabgp/vendoring/bitstring.py 644 /usr/bin/env python
exabgp.noarch: W: spelling-error Summary(en_US) swiss -> swiz, Swiss, swigs
exabgp.noarch: W: spelling-error %description -l en_US healthcheck -> health check, health-check, leatherneck
exabgp.noarch: W: spelling-error %description -l en_US maintenances -> maintenance, maintenance's, maintenance s
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-add-remove.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-add-remove.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-announce.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-announce.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-announcement.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-announcement.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-api.nothing.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-api.nothing.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-api.receive.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-api.receive.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-attributes.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-attributes.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-broken-flow.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-broken-flow.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-check.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-check.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-eor.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-eor.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-fast.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-fast.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-flow.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-flow.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-multi-neighbor.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-multi-neighbor.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-multisession.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-multisession.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-nexthop-self.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-nexthop-self.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-nexthop.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-nexthop.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-notification.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-notification.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-open.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-open.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-reload.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-reload.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-teardown.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-teardown.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-vpls.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-vpls.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/api-vpnv4.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/api-vpnv4.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/manual-eor.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/manual-eor.run 644 /usr/bin/env python
exabgp.noarch: E: wrong-script-interpreter /etc/exabgp/examples/watchdog.run /usr/bin/env python
exabgp.noarch: E: non-executable-script /etc/exabgp/examples/watchdog.run 644 /usr/bin/env python
exabgp.noarch: E: script-without-shebang /usr/lib/systemd/system/exabgp.service
exabgp.noarch: E: non-standard-dir-perm /usr/share/exabgp/etc 644
exabgp.noarch: E: non-standard-dir-perm /usr/share/exabgp/processes 644
exabgp.noarch: E: non-standard-executable-perm /usr/share/exabgp/processes/watchdog-1.sh 744
exabgp.noarch: W: spurious-executable-perm /usr/share/man/man1/exabgp.1.gz
exabgp.noarch: W: manual-page-warning /usr/share/man/man1/exabgp.1.gz 3: warning: macro `OS' not defined
exabgp.noarch: W: spurious-executable-perm /usr/share/man/man5/exabgp.conf.5.gz
exabgp.noarch: W: manual-page-warning /usr/share/man/man5/exabgp.conf.5.gz 3: warning: macro `OS' not defined
exabgp.noarch: W: no-manual-page-for-binary exabgp-healthcheck
python-exabgp.src: W: spelling-error Summary(en_US) swiss -> swiz, Swiss, swigs
3 packages and 0 specfiles checked; 68 errors, 11 warnings.




Requires
--------
python-exabgp (rpmlib, GLIBC filtered):
    python(abi)
    python-ipaddr
    python-six
    python2

exabgp (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    /usr/bin/perl
    /usr/bin/python2
    config(exabgp)
    systemd



Provides
--------
python-exabgp:
    python-exabgp
    python2.7dist(exabgp)
    python2dist(exabgp)

exabgp:
    config(exabgp)
    exabgp



Source checksums
----------------
https://github.com/Exa-Networks/exabgp/archive/4.0.0.tar.gz :
  CHECKSUM(SHA256) this package     : 054edde08d9d60789435e6848a2d3fba5718f14e49cb79a440c119a96cab7f6a
  CHECKSUM(SHA256) upstream package : 054edde08d9d60789435e6848a2d3fba5718f14e49cb79a440c119a96cab7f6a


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1452649
Buildroot used: fedora-26-x86_64
Active plugins: Python, Generic, Shell-api, Perl
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 11 Luke Hinds 2017-05-30 09:37:53 UTC
Spec file and SRPM updated.

Current status:

Issues:
=======
- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions

Comment 12 Richard W.M. Jones 2017-05-30 10:26:50 UTC
(In reply to Richard W.M. Jones from comment #10)
> - Package contains BR: python2-devel or python3-devel
> 
> I don't know why fedora-review prints this, but according to the
> Python packaging guidelines this is fine.

Fixed by adding BR: python2-devel

> - Package does not contain duplicates in %files.
>   Note: warning: File listed twice: /etc/exabgp/exabgp.conf
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles
> 
> This is a bug.

This is fixed by removing the duplicate line.

> [!]: Package requires other packages for directories it uses.
>      Note: No known owner of /usr/share/exabgp
> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners: /usr/share/exabgp
> 
> Probably need to add %dir for this directory.
> 
> By the way, in the spec you can use %{_datadir} instead of
> %{_prefix}/share.

This is not fixed.

> [!]: Each %files section contains %defattr if rpm < 4.4
>      Note: %defattr present but not needed
> 
> %defattr isn't required even for RHEL 7, so this should be deleted
> unless you're really intending to use this spec file for ancient
> versions of RPM.

Not fixed.

> [!]: Requires correct, justified where necessary.
> 
> It seems as if the exabgp subpackage should have
> ‘Requires: %{name} = %{version}-%{release}’.
> 
> Currently the exabgp package requires ‘config(exabgp)’ which
> python-exabgp provides, but that won't be sufficient to pull in the
> correct version.

Not fixed.

> [ ]: Package complies to the Packaging Guidelines
> 
> Possibly, but I still think the not-really-config /etc/exabgp/examples
> files should be moved to /usr/lib/exabgp.

Not changed.

> [ ]: Final provides and requires are sane (see attachments).
> 
> I suspect exabgp should require python-exabgp.  The other dependencies
> look fine.
> 
> [!]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in exabgp
> 
> See above.

See above.

Comment 13 Luke Hinds 2017-05-30 14:36:07 UTC
Apologies, I did not git add the newer spec and srpm:

>> [!]: Package requires other packages for directories it uses.
>>      Note: No known owner of /usr/share/exabgp
>> [!]: Package must own all directories that it creates.
>>      Note: Directories without known owners: /usr/share/exabgp
>> 
>> Probably need to add %dir for this directory.
>> 
>> By the way, in the spec you can use %{_datadir} instead of
>> %{_prefix}/share.

> This is not fixed.

This should be fixed now. 

I used the following lines:

%dir %{_datadir}/exabgp
%dir %{_datadir}/exabgp/processes

>> [!]: Each %files section contains %defattr if rpm < 4.4
>>      Note: %defattr present but not needed
>> 
>> %defattr isn't required even for RHEL 7, so this should be deleted
>> unless you're really intending to use this spec file for ancient
>> versions of RPM.

> Not fixed.

Removed %defattr

>> [!]: Requires correct, justified where necessary.
>> 
>> It seems as if the exabgp subpackage should have
>> ‘Requires: %{name} = %{version}-%{release}’.
>> 
>> Currently the exabgp package requires ‘config(exabgp)’ which
>> python-exabgp provides, but that won't be sufficient to pull in the
>> correct version.

> Not fixed.

Added: Requires: %{name} = %{version}-%{release}

>> [ ]: Package complies to the Packaging Guidelines
>> 
>> Possibly, but I still think the not-really-config /etc/exabgp/examples
>> files should be moved to /usr/lib/exabgp.

> Not changed.

Now using lib (or rather lib64 which is referenced by _libdir)

mv ${RPM_BUILD_ROOT}/usr/share/exabgp/etc/* ${RPM_BUILD_ROOT}/%{_libdir}/exabgp/


>> [ ]: Final provides and requires are sane (see attachments).
>> 
>> I suspect exabgp should require python-exabgp.  The other dependencies
>> look fine.
>> 
>> [!]: Fully versioned dependency in subpackages if applicable.
>>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in exabgp
>> 
>> See above.

I get a pass on this now.

[x]: Fully versioned dependency in subpackages if applicable.

I also have no failures [!] and the only `Issue` is:

- Permissions on files are set properly

Comment 14 Richard W.M. Jones 2017-05-30 14:53:54 UTC
Good, it looks like everything is fixed satisfactorily in the
latest release.

*** Therefore I am APPROVING this package for Fedora ***

You must now continue the process here:

https://fedoraproject.org/wiki/Join_the_package_collection_maintainers#Get_Sponsored

I believe you're either at step "Get sponsored" or
"Add Package to Source Code Management (SCM) system".

Let me know if there's anything else I can help with.

Comment 15 Haïkel Guémar 2017-06-19 11:27:27 UTC
I sponsor lhinds.

Comment 16 Gwyn Ciesla 2017-06-19 13:04:03 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-exabgp

Comment 17 Fedora Update System 2017-06-20 11:52:00 UTC
python-exabgp-4.0.0-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-9aca13bcc7

Comment 18 Fedora Update System 2017-06-20 11:52:11 UTC
python-exabgp-4.0.0-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-9aca13bcc7

Comment 19 Thomas Mangin 2017-06-20 15:28:04 UTC
Thank you for this work. Much appreciated.

As I noticed that you would have preferred to see the copyright in every file.
I fired my editor and done some search and replace before 4.0.1:

https://github.com/Exa-Networks/exabgp/commit/dbd58a009c70628d89e7831aa1175fb5f52e9a28

If ever you ever find anything which does not follow any Fedora Guideline, I will happily fix it.

Comment 20 Richard W.M. Jones 2017-06-20 15:39:36 UTC
I would say the most important issue we found are the not-really-config
files in /etc/exabgp/examples.  I'm not sure if it is intended that
users edit those.  If not, then Fedora (and other distros) would prefer
that those files are moved somewhere else, perhaps /usr/share if they
are non-architecture-specific text files.

Of course it's fine to have a symlink from /etc/exabgp/exabgp.conf
to /usr/share, and also fine for users to copy files from /usr/share
to /etc/exabgp when they really want to make local config changes.

Comment 21 Fedora Update System 2017-06-21 06:23:46 UTC
python-exabgp-4.0.0-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-9aca13bcc7

Comment 22 Thomas Mangin 2017-06-21 13:00:52 UTC
@Richard - As the author of ExaBGP, I can only fix the "upstream" issues. I have made changes and the etc/exabgp folder of the repo is now a clear "list of example" for users, and I would also invite the move of these files into /usr/share.

Comment 23 Luke Hinds 2017-06-21 13:03:41 UTC
@Thomas, is that on master? We are pinned to 4.0.0, so I will make the changes in the spec for the next release.

Comment 24 Thomas Mangin 2017-06-21 14:58:41 UTC
Yes, this is on master and will be for 4.0.1 which I would hope to release as soon as possible. 4.0.0 being a 0.0 release has quite a few 'interesting behaviours' :p

Comment 25 Thomas Mangin 2017-06-23 16:12:03 UTC
4.0.1 was released today

Comment 26 Haïkel Guémar 2017-07-05 13:02:53 UTC
You can close the ticket and proceed with the 4.0.1 update without holding off.


Note You need to log in before you can comment on or make changes to this bug.